<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" inline>
      <el-form-item label="主题名称：" prop="topicName">
        <el-input v-model="queryParams.topicName" placeholder="请输入主题名称" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="备注：" prop="topicName">
        <el-input v-model="queryParams.remark" placeholder="请输入备注" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="当前状态：" prop="status">
        <el-select v-model="queryParams.status" placeholder="主题状态" clearable style="width: 240px">
          <el-option v-for="dict in sys_normal_disable" :key="dict.value" :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item label="创建时间：" style="width: 308px;">
        <el-date-picker v-model="dateRange" value-format="YYYY-MM-DD" type="daterange" start-placeholder="开始日期"
          end-placeholder="结束日期"></el-date-picker>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
        <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['mqtt:topic:add']">新增</el-button>
        <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['mqtt:topic:remove']">删除</el-button>
        <el-button type="warning" plain icon="Download" @click="handleExport"
          v-hasPermi="['mqtt:topic:export']">导出</el-button>
      </el-form-item>
    </el-form>

    <el-table v-loading="loading" :data="topicList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="ID" align="center" prop="id" />
      <el-table-column label="主题名称" align="center" prop="topicName" />
      <el-table-column label="状态" align="center" key="status">
        <template #default="scope">
          <el-switch v-model="scope.row.status" active-value="0" inactive-value="1" disabled />
        </template>
      </el-table-column>
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column label="创建时间" align="center" prop="createTime" />
      <el-table-column label="更新时间" align="center" prop="updateTime" />
      <el-table-column label="操作" align="center">
        <template #default="scope">
          <el-button link type="primary" @click="handleUpdate(scope.row)" v-hasPermi="['mqtt:topic:edit']">编辑</el-button>
          <el-button link type="danger" @click="handleDelete(scope.row)" v-hasPermi="['mqtt:topic:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize"
      @pagination="getList" />

    <!-- 添加或修改设备主题对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="topicRef" :model="form" :rules="rules" label-width="auto">
        <el-form-item label="主题名称：" prop="topicName">
          <el-input v-model="form.topicName" placeholder="请输入主题名称" />
        </el-form-item>
        <el-form-item label="当前状态：" prop="status">
          <el-select v-model="form.status" placeholder="请选择当前状态">
            <el-option v-for="dict in sys_normal_disable" :key="dict.value" :label="dict.label" :value="dict.value" />
          </el-select>
        </el-form-item>
        <el-form-item label="备注：" prop="remark">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入内容" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Topic">
import { listTopic, getTopic, delTopic, addTopic, updateTopic } from "@/api/mqtt/topic";

const { proxy } = getCurrentInstance();
const { sys_normal_disable } = proxy.useDict("sys_normal_disable");
const topicList = ref([]);
const open = ref(false);
const loading = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");
const dateRange = ref([]);

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    topicName: null,
    remark: null,
    status: null,
  },
  rules: {
    topicName: [{
      required: true, message: "主题名称不能为空", trigger: "blur"
    }],
    status: [{
      required: true, message: '请选择当前状态', trigger: "change"
    }]
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询设备主题列表 */
function getList() {
  loading.value = true;
  loading.value = true;
  listTopic(proxy.addDateRange(queryParams.value, dateRange.value)).then(res => {
    loading.value = false;
    topicList.value = res.rows;
    total.value = res.total;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    id: null,
    topicName: null,
    status: null,
    delFlag: null,
    createBy: null,
    createTime: null,
    updateBy: null,
    updateTime: null,
    remark: null
  };
  proxy.resetForm("topicRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  dateRange.value = [];
  proxy.resetForm("queryRef");
  queryParams.value.remark = undefined;
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加设备主题";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _id = row.id || ids.value
  getTopic(_id).then(response => {
    form.value = response.data;
    open.value = true;
    title.value = "修改设备主题";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["topicRef"].validate(valid => {
    if (valid) {
      if (form.value.id != null) {
        updateTopic(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addTopic(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value;
  proxy.$modal.confirm('是否确认删除设备主题编号为"' + _ids + '"的数据项？').then(function () {
    return delTopic(_ids);
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  }).catch(() => { });
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('device/topic/export', {
    ...queryParams.value
  }, `topic_${new Date().getTime()}.xlsx`)
}

getList();
</script>
